################################################################################
#  GTChat 0.95 Alpha Plugin                                                    #
#  Written for release 20030110                                                #
#  Author: Wladmir Palant                                                      #
#  Changed: Norman Rath                                                        #
#                                                                              #
#  This plugin is a simple chat bot sample                                     #
#                                                                              #
################################################################################

package GTChat::Plugins::Botty;
use strict;

return bless({
	command_handlers => {
		'botty' => \&commandHandler1,
		'botty2' => \&commandHandler2,
	},
});

sub checkText
{
	my($self,$main,$text) = @_;

	
	if ($$text =~ s/^\botty\s+Botty(\s+|$)//)
	{
		$$text = '/botty '.$$text;
	}
	if ($$text =~ s/^\bot\s+Botty(\s+|$)//)
	{
		$$text = '/botty '.$$text;
	}
	if ($$text =~ s/^\@Botty(\s+|$)// || $$text =~ s/\s+\@Botty$// || $$text =~ s/^Botty:(\s+|$)//)
	{
		$$text = '/botty2 '.$$text;
	}
}


sub check_gagged
{
	my $main = shift;

	if (exists($main->{current_user}{gagtime}) && $main->{runtime}{now} < $main->{current_user}{gagtime})
	{
		return [$main->createErrorOutput('gagged',{seconds => $main->{current_user}{gagtime}-$main->{runtime}{now}})];
	}
	return undef;
}

sub commandHandler1
{
	my($self,$main,$command,$text) = @_;
	
	if (my $error=check_gagged($main))
	{
		return $error;
	}

	my $answer = getAnswer($text);	
	my $output1 = $main->createOutput(
				{
					template => 'messages_top',
					toname => 'botty',
					tonick => 'Botty',
					color => $main->{current_user}{color},
					text => $main->toHTML($text),
					url => '',
				});
	$output1->restrictToCurrentRoom();
				
	my $output2 = $main->createOutput(
				{
					template => 'private',
					name => 'botty',
					nick => 'Botty',
					color => $main->{settings}{default}{color},
					text => $main->toHTML($answer),
					url => '',
				});
	$output2->restrictToCurrentUser();
				
	return [$output1,$output2];
}

sub commandHandler2
{
	my($self,$main,$command,$text) = @_;

	my @ret=();
	
	my $answer = getAnswer($text);

	if (my $error=check_gagged($main))
	{
		return $error;
	}

	if ($main->{current_user}{away})
	{
		$main->{current_user}{away} = 0;
		
		my $output = $main->createInfoOutput('awayoff',{nick => $main->{current_user}{nick}});
		push @ret, $output->restrictToUser->restrictToCurrentRoom->setChangedAttributes('away');
	}
	
	my $output1 = $main->createOutput(
				{
					template => 'botty',
					name => $main->{current_user}{name},
					nick => $main->{current_user}{nick},
					color => $main->{current_user}{color},
					text => $main->toHTML($text),
					url => '',
					botty => '1',
				});
	push @ret, $output1->restrictToCurrentRoom();
				
	my $output2 = $main->createOutput(
				{
					template => 'botty',
					toname => $main->{current_user}{name},
					tonick => $main->{current_user}{nick},
					color => $main->{settings}{default}{color},
					text =>  $main->toHTML($answer),
					url => '',
					botty => '',
				});
	push @ret, $output2->restrictToCurrentUser();

	return \@ret;
}

sub getAnswer
{
	my $text = shift;

	srand;
	
	if ($text =~ /\bhallo\b/i || $text =~ /\bhi\b/i)
	{
		my @Zeilen = ('Hallo au...!','Na hallo, wer bisch Du dnn?','Hi Du, na wie gaht's Dir?','Hallihallohallle');
		my $i = int(rand(@Zeilen +1) -1);
		return ($Zeilen[$i]);
	}
	elsif ($text =~ /\btest\b/i)
	{
		return 'Glckwunsch, hsch d Test bestand!';
	}
        elsif ($text =~ /\bdumm\b/i || $text =~ /\bdoof\b/i || $text =~ /\bbld\b/i)
        {
		my @Zeilen = ('Bitte nicht in diesem Ton!','Das habe ich jetzt berhrt!','Pass blos auf .....duuuuuuu!!!');
		my $i = int(rand(@Zeilen +1) -1);
		return ($Zeilen[$i]);
        }
        elsif ($text =~ /\bhast\b/i and $text =~ /\bhomepage\b/i || $text =~ /\bwebseite\b/i || $text =~ /\bwww\b/i)
        {
		my @Zeilen = ('Ja klar doch, schau hier www.botty.de','Nein, aber nimm dich diese www.test.de');
		my $i = int(rand(@Zeilen +1) -1);
		return ($Zeilen[$i]);
        }
        elsif ($text =~ /\bmein name\b/i || $text =~ /\bheisse\b/i || $text =~ /\bheie\b/i)
        {
		my @Zeilen = ('Angenehm, ich bin Botty.','Schner Name, ich bin der Botty','Ich heisse Botty');
		my $i = int(rand(@Zeilen +1) -1);
		return ($Zeilen[$i]);
        }
        elsif ($text =~ /\bfreundin\b/i || $text =~ /\blover\b/i || $text =~ /\bfreund\b/i)
        {
                return 'Was denkst Du wie sich Bottys vermehren? Durch Zellteilung?...tztztz';
        }
 elsif ($text =~ /\bAddon\b/i || $text =~ /\binstallation addon\b/i || $text =~ /\binstalliere Addon\b/i)
        {
                return 'Um ein Addon zu installieren gibt es verschiedene Vorgehensweisen aber die beste ist wohl : genau die installations anleitung des entsprechenden Addons zu lesen und auch wirklich nur das zu machen was dort drin steht! Eine Liste der Addons findest du hier http://www.gtchatforum.de/board.php?boardid=18&sid=';
        }

        elsif ($text =~ /\bzigarette\b/i || $text =~ /\bziggi\b/i || $text =~ /\bkippe\b/i || $text =~ /\bzigarre\b/i)
        {
		my @Zeilen = ('Rauchen gefhrdet die Gesundheit','Rauchen verursacht Krebs','Wer das Rauchen aufgibt, verhindert das Entstehen schwerer Erkrankungen');
		my $i = int(rand(@Zeilen +1) -1);
		return ($Zeilen[$i]);
        }
        elsif ($text =~ /\bwie\b/i and $text =~ /\balt\b/i || $text =~ /\bjung\b/i)
        {
		my @Zeilen = ('Das verrat ich nicht ;)','Hmm, weiss ich nicht genau. Frag mal den Chat-Master!','Viel zu Alt fr Dich ;D');
		my $i = int(rand(@Zeilen +1) -1);
		return ($Zeilen[$i]);
        }
        elsif ($text =~ /\bmich\b/i and $text =~ /\bmagst\b/i || $text =~ /\bliebst\b/i)
        {
		my @Zeilen = ('Ich liebe nur mich','Ja, mchtest Du mich heiraten?','Natrlich, ich mag jeden Chatter hier');
		my $i = int(rand(@Zeilen +1) -1);
		return ($Zeilen[$i]);
        }
	elsif ($text =~ /\bwer\b/i)
	{
		return 'Ach, ich bin doch nur der Chat-Bot hier.';
	}
	elsif ($text =~ /\bficken\b/i || $text =~ /\bpoppen\b/i || $text =~ /\bbumsen\b/i || $text =~ /\bsex\b/i)
	{
		my @Zeilen = ('Zu mir oder zu Dir?','Ich mags aber richtig heftig. Schaffst Du das?','Sorry, jetzt habe ich keine Lust dazu. Spter vielleicht :)','Mit mir? Nee, nimm doch den Chat-Master.');
		my $i = int(rand(@Zeilen +1) -1);
		return ($Zeilen[$i]);
	}
	elsif ($text =~ /\?$/)
	{
		return 'War das jetzt eine Frage oder eine Behauptung?';
	}
       else {
#Erstellen eines Logiles fr neue Sprche
	   open (datei, ">>./Variables/bottylog.txt") or die "die bottylog kann nicht gendert werden! $! ";
           print datei "$text\n";
           close (datei);
#Ende erstellen eines Logiles fr neue Sprche

		my @Zeilen = ('Sprich nicht so schnell, ich bin Blond','das vertehe ich nicht, bin ein blonder Bot','nu hr doch mal auf zu nuscheln, versteh ja nichts','welche Sprache ist denn das nu wieder?','Kannst du bitte Lauter sprechen? Ich versteh dich nicht','Ja, Ja htt ich auch gesagt...**grins**','Dummmdidummmmmmmm','Lalalalalalalalal........');
		my $i = int(rand(@Zeilen +1) -1);
		return ($Zeilen[$i]);
	}
}

