###################################################################
#  GTChat 0.95 Alpha Plugin                                       #
#  Written for release 20021101                                   #
#  Author: Raphael Huwiler                                        #
#                                                                 #
#  This plugin provides the action for delete the offline msg.    #                                            #
###################################################################

package GTChat::Plugins::CommandHandlers::DeleteMsg;

 return bless({
	action_handlers => {
		deletemsg  => \&actionHandler,
		},
	});

sub convertName
{
	my($main,$name) = @_;
	
	$name =~ s/^\s+|\s+$//g;
	$name =~ s/[\s $main->{settings}{custom_forbidden_chars}]/_/g;
	
	return $main->lowercase($name);
}

sub actionHandler
{
	my ($self,$main,$user,$name) = @_;

	#Remove the user's msg file
	my $filename = unpack("H*",$main->{current_user}{name});
	unlink($main->translateName("offlinedir::$filename.msg"));

	$main->printTemplate('deletemsg');
}

