package GTChat::Plugins::DiceCommand::095_01;
use strict;

return bless({
	command_handlers => {
		'dice' => \&handler,
	},
});

sub handler
{
	my($self,$main,$command,$text) = @_;

	# berprfung der Parameter
	my($edges,$dices) = split(/\s/,$text);
	$edges = 6 unless defined($edges) && $edges>0;  # Standard-Seitenzahl fr den Wrfel ist 6
	$edges = int($edges);
	$dices = 2 unless defined($dices) && $dices>0 && $dices<=12;  # Standard-Wrfelzahl ist 1, maximal sind 12 Wrfel erlaubt
	$dices = int($dices);

	# Zufallszahlen von 1 bis $edges berechnen
	srand;
	my @random = ();
	my $sum = 0;
	for (1..$dices)
	{
		push @random, int(rand($edges))+1;
		$sum += $random[-1];
	}

	# Ausgabe erstellen
	my $output = $main->createInfoOutput('dice',{nick => $main->{current_user}{nick}, dices => $dices, edges => $edges, numbers => join(', ',@random), sum => $sum});
	$output->restrictToCurrentRoom(); # Ausgabe an alle Chatter im aktuellen Raum schicken

	return [$output];
}
