###################################################################
#  GTChat 0.95 Alpha Plugin                                       #
#  Written for release 20021101                                   #
#  Author: Michael Skrenkovic                                     #
#                                                                 #
#  This plugin provides the chat commands /friend                 #
###################################################################

package GTChat::Plugins::FriendCommand::;
use strict;

return bless({
	command_handlers => {
		'friend' => \&friend_handler,
		
	},
});

sub friend_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);
	
	return [$main->createErrorOutput('kick_namenotgiven')] unless defined($nick);
	
	my $candidates = $main->getPossibleOnlineUsers($nick);

	return [$main->createErrorOutput('notonline',{nick => $nick})] if ($#$candidates < 0);
	return [$main->createErrorOutput('ambiguousname',{nick => $nick})] if ($#$candidates > 0);

	my $user = $candidates->[0];

	return [$main->createErrorOutput('friend_again',{nick => $user->{nick}})] if ($main->{current_user}{friends} ne "");
	return [$main->createErrorOutput('friend_self',{nick => $user->{nick}})] if ($main->{current_user}{name} eq $user->{name});
	return [$main->createErrorOutput('friend_blocked',{nick => $user->{nick}})] if ($main->{current_user}{points} < 500);
	return [$main->createErrorOutput('friend_gast',{nick => $user->{nick}})] if ($user->{tempgroup} == -1);
                 
	$main->loadUser($main->{current_user}{name},$main->{current_user});

	return [$main->createErrorOutput('friend_already',{nick => $user->{nick}})] if ($main->{current_user}{nick}=~m/$user->{friends}/);

	$main->{current_user}{friends}=$user->{friends};
	$main->{current_user}{friendscount}=$user->{friendscount} +1; 
       
	$main->saveUser($main->{current_user});

        $main->loadUser($user->{name},$user);

	$user->{friendsmeup}=$user->{friendsmeup} +1;
	$user->{friendmeupnames}=$user->{friends} . " $main->{current_user}{nick}, ";
	$main->saveUser($user);

	my $info = $main->createInfoOutput('newfriend',
					{
						admin => $main->{current_user}{nick},
						nick => $user->{nick},
					});
	$info->restrictToCurrentUser;

	return [$info];
}