###################################################################
#  GTChat 0.95 Alpha Plugin                                       #
#  Written for release 20030110                                   #
#  Author: Norman Rath                                            #
#                                                                 #
#  This plugin provides the ghost command /ghost                  #
###################################################################

package GTChat::Plugins::GhostCommand;
use strict;

return bless({
	command_handlers => {
		'ghost' => \&commandHandler,
	},
});

sub commandHandler
{
	my($self,$main,$command) = @_;

	my $user = $main->{current_user};

	return [$main->createErrorOutput('command_nopermission')] if ($user->{tempgroup} < 6); # Rang anpassen

	if($main->{current_user}{tempgroup} ne 6) # Rang anpassen
	{
		$user->{tempgroup} = 6; # Rang anpassen
		my $output = $main->createInfoOutput('ghost_on');
		return [$output->restrictToCurrentUser->setChangedAttributes('tempgroup')];
	}
	else
	{
		$user->{tempgroup} = $user->{group};
		my $output = $main->createInfoOutput('ghost_off');
		return [$output->restrictToCurrentUser->setChangedAttributes('tempgroup')];
	}
}

