###################################################################
#  GTChat 0.95 Alpha Plugin                                       #
#  Written for release 20021101                                   #
#  Author: Norman Rath                                            #
#                                                                 #
#  This plugin provides the scream command /scream                #
###################################################################

package GTChat::Plugins::ScreamCommand;
use strict;

return bless({
	command_handlers => {
		'scream' => \&commandHandler,
	},
});

sub check_gagged
{
	my $main = shift;

	if (exists($main->{current_user}{gagtime}) && $main->{runtime}{now} < $main->{current_user}{gagtime})
	{
		return [$main->createErrorOutput('gagged',{seconds => $main->{current_user}{gagtime}-$main->{runtime}{now}})];
	}
	return undef;
}

sub commandHandler
{
	my($self,$main,$command,$text) = @_;

	my @ret=();

	if (my $error=check_gagged($main))
	{
		return $error;
	}
	
	if ($main->{current_user}{away})
	{
		$main->{current_user}{away} = 0;
		
		my $output = $main->createInfoOutput('awayoff',{nick => $main->{current_user}{nick}});
		push @ret, $output->restrictToUser->restrictToCurrentRoom->setChangedAttributes('away');
	}

	my(@parts) = split(/\s+/,$text);
	$text = join(' ',@parts);
	$text = uc($text);

	return \@ret if ($text eq '');

	my $output = $main->createOutput(
		{
			template => 'scream',
			name => $main->{current_user}{name},
			nick => $main->{current_user}{nick},
			color => $main->{current_user}{color},
			text => $main->toHTML($text),
		});
	push @ret, $output->restrictToCurrentRoom;

	return \@ret;
}

