###################################################
# Addon for GT Chat 0.95 Alpha                    #
# Author: Dennis St.                              #
# E-Mail: webmaster@chat-it.de                    #
#                                                 #
# Der Autor mchte KEINE nderung an diesem Addon #
###################################################

use strict;

return bless({
	command_handlers => {
		'hau' => \&hau_handler,
                'umarm' => \&umarm_handler,
                'bb' => \&bb_handler,
                'hi' => \&hi_handler,
                'pack' => \&pack_handler,
                'wc' => \&wc_handler,
                'vernasch' => \&vernasch_handler,
		'ecke' => \&ecke_handler,
		'bier' => \&bier_handler,
		'bett' => \&bett_handler,
		'vermiss' => \&vermiss_handler,
	},
});

sub check_gagged
{
	my $main = shift;

	if (exists($main->{current_user}{gagtime}) && $main->{runtime}{now} < $main->{current_user}{gagtime})
	{
		return [$main->createErrorOutput('gagged',{seconds => $main->{current_user}{gagtime}-$main->{runtime}{now}})];
	}
	return undef;
}

                   #Hau Spruch mit Nicknamen
sub hau_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);

        if (my $error=check_gagged($main))
	{
		return $error;
	}

       else
{
	return [$main->createErrorOutput('kick_namenotgiven')] unless defined($nick);

	my $candidates = $main->getPossibleOnlineUsers($nick);

	return [$main->createErrorOutput('notonline',{nick => $nick})] if ($#$candidates < 0);
	return [$main->createErrorOutput('ambiguousname',{nick => $nick})] if ($#$candidates > 0);

	my $user = $candidates->[0];

        return [$main->createErrorOutput('hau_self')] if ($user->{name} eq $main->{current_user}{name});

	my $info = $main->createInfoOutput('hau',
					{
						admin => $main->{current_user}{nick},
						nick => $user->{nick},
					});
	$info->restrictToCurrentRoom();

	return [$info];
}

}
                   #Umarm Spruch mit Nicknamen
sub umarm_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);

        if (my $error=check_gagged($main))
	{
		return $error;
	}

       else
{
	return [$main->createErrorOutput('kick_namenotgiven')] unless defined($nick);

	my $candidates = $main->getPossibleOnlineUsers($nick);

	return [$main->createErrorOutput('notonline',{nick => $nick})] if ($#$candidates < 0);
	return [$main->createErrorOutput('ambiguousname',{nick => $nick})] if ($#$candidates > 0);

	my $user = $candidates->[0];

        return [$main->createErrorOutput('umarm_self')] if ($user->{name} eq $main->{current_user}{name});

	my $info = $main->createInfoOutput('umarm',
					{
						admin => $main->{current_user}{nick},
						nick => $user->{nick},
					});
	$info->restrictToCurrentRoom();

	return [$info];
}

}

                   #Bye Spruch ohne Nicknamen
sub bb_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);

        if (my $error=check_gagged($main))
	{
		return $error;
	}

       else
{
	my $candidates = $main->getPossibleOnlineUsers($nick);

	my $user = $candidates->[0];

	my $info = $main->createInfoOutput('bb',
					{
						admin => $main->{current_user}{nick},
					});
	$info->restrictToCurrentRoom();

	return [$info];
}

}
 

                  #Hoi Spruch ohne Nicknamen
sub hi_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);

        if (my $error=check_gagged($main))
	{
		return $error;
	}

       else
{
	my $candidates = $main->getPossibleOnlineUsers($nick);

	my $user = $candidates->[0];

	my $info = $main->createInfoOutput('hi',
					{
						admin => $main->{current_user}{nick},
					});
	$info->restrictToCurrentRoom();

	return [$info];
}

}

                   #Pack Spruch mit Nicknamen
sub pack_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);

        if (my $error=check_gagged($main))
	{
		return $error;
	}

       else
{
	return [$main->createErrorOutput('kick_namenotgiven')] unless defined($nick);

	my $candidates = $main->getPossibleOnlineUsers($nick);

	return [$main->createErrorOutput('notonline',{nick => $nick})] if ($#$candidates < 0);
	return [$main->createErrorOutput('ambiguousname',{nick => $nick})] if ($#$candidates > 0);

	my $user = $candidates->[0];

        return [$main->createErrorOutput('pack_self')] if ($user->{name} eq $main->{current_user}{name});

	my $info = $main->createInfoOutput('pack',
					{
						admin => $main->{current_user}{nick},
						nick => $user->{nick},
					});
	$info->restrictToCurrentRoom();

	return [$info];
}

}

                   #WC Spruch ohne Nicknamen
sub wc_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);

        if (my $error=check_gagged($main))
	{
		return $error;
	}

       else
{
	my $candidates = $main->getPossibleOnlineUsers($nick);

	my $user = $candidates->[0];

	my $info = $main->createInfoOutput('wc',
					{
						admin => $main->{current_user}{nick},
					});
	$info->restrictToCurrentRoom();

	return [$info];
}

}

                   #Vernasch Spruch mit Nicknamen
sub vernasch_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);

        if (my $error=check_gagged($main))
	{
		return $error;
	}

       else
{
	return [$main->createErrorOutput('kick_namenotgiven')] unless defined($nick);

	my $candidates = $main->getPossibleOnlineUsers($nick);

	return [$main->createErrorOutput('notonline',{nick => $nick})] if ($#$candidates < 0);
	return [$main->createErrorOutput('ambiguousname',{nick => $nick})] if ($#$candidates > 0);

	my $user = $candidates->[0];

        return [$main->createErrorOutput('vernasch_self')] if ($user->{name} eq $main->{current_user}{name});

	my $info = $main->createInfoOutput('vernasch',
					{
						admin => $main->{current_user}{nick},
						nick => $user->{nick},
					});
	$info->restrictToCurrentRoom();

	return [$info];
}

}

		#Ecke Spruch mit Nicknamen
sub ecke_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);

        if (my $error=check_gagged($main))
	{
		return $error;
	}

       else
{
	return [$main->createErrorOutput('kick_namenotgiven')] unless defined($nick);

	my $candidates = $main->getPossibleOnlineUsers($nick);

	return [$main->createErrorOutput('notonline',{nick => $nick})] if ($#$candidates < 0);
	return [$main->createErrorOutput('ambiguousname',{nick => $nick})] if ($#$candidates > 0);

	my $user = $candidates->[0];

        return [$main->createErrorOutput('ecke_self')] if ($user->{name} eq $main->{current_user}{name});

	my $info = $main->createInfoOutput('ecke',
					{
						admin => $main->{current_user}{nick},
						nick => $user->{nick},
					});
	$info->restrictToCurrentRoom();

	return [$info];
}

}
		#Bier Spruch mit Nicknamen
sub bier_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);

        if (my $error=check_gagged($main))
	{
		return $error;
	}

       else
{
	return [$main->createErrorOutput('kick_namenotgiven')] unless defined($nick);

	my $candidates = $main->getPossibleOnlineUsers($nick);

	return [$main->createErrorOutput('notonline',{nick => $nick})] if ($#$candidates < 0);
	return [$main->createErrorOutput('ambiguousname',{nick => $nick})] if ($#$candidates > 0);

	my $user = $candidates->[0];

        return [$main->createErrorOutput('bier_self')] if ($user->{name} eq $main->{current_user}{name});

	my $info = $main->createInfoOutput('bier',
					{
						admin => $main->{current_user}{nick},
						nick => $user->{nick},
					});
	$info->restrictToCurrentRoom();

	return [$info];
}

}

		#Bett Spruch mit Nicknamen
sub bett_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);

        if (my $error=check_gagged($main))
	{
		return $error;
	}

       else
{
	return [$main->createErrorOutput('kick_namenotgiven')] unless defined($nick);

	my $candidates = $main->getPossibleOnlineUsers($nick);

	return [$main->createErrorOutput('notonline',{nick => $nick})] if ($#$candidates < 0);
	return [$main->createErrorOutput('ambiguousname',{nick => $nick})] if ($#$candidates > 0);

	my $user = $candidates->[0];

        return [$main->createErrorOutput('bett_self')] if ($user->{name} eq $main->{current_user}{name});

	my $info = $main->createInfoOutput('bett',
					{
						admin => $main->{current_user}{nick},
						nick => $user->{nick},
					});
	$info->restrictToCurrentRoom();

	return [$info];
}

}
		#Vermiss Spruch mit Nicknamen
sub vermiss_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);

        if (my $error=check_gagged($main))
	{
		return $error;
	}

       else
{
	return [$main->createErrorOutput('kick_namenotgiven')] unless defined($nick);

	my $candidates = $main->getPossibleOnlineUsers($nick);

	return [$main->createErrorOutput('notonline',{nick => $nick})] if ($#$candidates < 0);
	return [$main->createErrorOutput('ambiguousname',{nick => $nick})] if ($#$candidates > 0);

	my $user = $candidates->[0];

        return [$main->createErrorOutput('vermiss_self')] if ($user->{name} eq $main->{current_user}{name});

	my $info = $main->createInfoOutput('vermiss',
					{
						admin => $main->{current_user}{nick},
						nick => $user->{nick},
					});
	$info->restrictToCurrentRoom();

	return [$info];
}

}