###################################################
# Addon for GT Chat 0.95 Alpha                    #
# Author: Dennis St.                              #
# E-Mail: webmaster@chat-it.de                    #
#                                                 #
# Der Autor mchte KEINE nderung an diesem Addon #
###################################################

use strict;

return bless({
	command_handlers => {
		'cu' => \&cu_handler,
                'mkiss' => \&mkiss_handler,
                'lach' => \&lach_handler,
                'admf' => \&admf_handler,
                'krank' => \&krank_handler,
                'werb' => \&werb_handler,
                'wirr' => \&wirr_handler,
                'wink' => \&wink_handler,
                'wein' => \&wein_handler,
                'rund' => \&rund_handler,
                'warn1' => \&warn1_handler,
		'warn2' => \&warn2_handler,
		'knuddel' => \&knuddel_handler,
		'wecken' => \&wecken_handler,
		'notime' => \&notime_handler,
		'erotik' => \&erotik_handler,
	},
});

sub check_gagged
{
	my $main = shift;

	if (exists($main->{current_user}{gagtime}) && $main->{runtime}{now} < $main->{current_user}{gagtime})
	{
		return [$main->createErrorOutput('gagged',{seconds => $main->{current_user}{gagtime}-$main->{runtime}{now}})];
	}
	return undef;
}






                   # CU Spruch ohne Nicknamen
sub cu_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);

        if (my $error=check_gagged($main))
	{
		return $error;
	}

       else
{
	my $candidates = $main->getPossibleOnlineUsers($nick);

	my $user = $candidates->[0];

	my $info = $main->createInfoOutput('cued',
					{
						admin => $main->{current_user}{nick},
					});
	$info->restrictToCurrentRoom();

	return [$info];
}
}

                   #Kuss Spruch mit Nicknamen
sub mkiss_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);

        if (my $error=check_gagged($main))
	{
		return $error;
	}

       else
{
	return [$main->createErrorOutput('kick_namenotgiven')] unless defined($nick);

	my $candidates = $main->getPossibleOnlineUsers($nick);

	return [$main->createErrorOutput('notonline',{nick => $nick})] if ($#$candidates < 0);
	return [$main->createErrorOutput('ambiguousname',{nick => $nick})] if ($#$candidates > 0);

	my $user = $candidates->[0];

        return [$main->createErrorOutput('mkiss_self')] if ($user->{name} eq $main->{current_user}{name});

	my $info = $main->createInfoOutput('mkissed',
					{
						admin => $main->{current_user}{nick},
						nick => $user->{nick},
					});
	$info->restrictToCurrentRoom();

	return [$info];
}

}

                   #Lach Spruch ohne Nicknamen
sub lach_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);

        if (my $error=check_gagged($main))
	{
		return $error;
	}

       else
{
	my $candidates = $main->getPossibleOnlineUsers($nick);

	my $user = $candidates->[0];

	my $info = $main->createInfoOutput('lached',
					{
						admin => $main->{current_user}{nick},
					});
	$info->restrictToCurrentRoom();

	return [$info];
}

}

                   #Admin Spruch ohne Nicknamen
sub admf_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);

        if (my $error=check_gagged($main))
	{
		return $error;
	}

       else
{
	my $candidates = $main->getPossibleOnlineUsers($nick);

	my $user = $candidates->[0];

	my $info = $main->createInfoOutput('admfed',
					{
						admin => $main->{current_user}{nick},
					});
	$info->restrictToCurrentRoom();

	return [$info];
}

}

                   #Krank Spruch mit Nickname
sub krank_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);

        if (my $error=check_gagged($main))
	{
		return $error;
	}

       else
{
	return [$main->createErrorOutput('kick_namenotgiven')] unless defined($nick);

	my $candidates = $main->getPossibleOnlineUsers($nick);

	return [$main->createErrorOutput('notonline',{nick => $nick})] if ($#$candidates < 0);
	return [$main->createErrorOutput('ambiguousname',{nick => $nick})] if ($#$candidates > 0);

	my $user = $candidates->[0];

        return [$main->createErrorOutput('krank_self')] if ($user->{name} eq $main->{current_user}{name});


	my $info = $main->createInfoOutput('kranked',
					{
						admin => $main->{current_user}{nick},
						nick => $user->{nick},
					});
	$info->restrictToCurrentRoom();

	return [$info];
}

}

                   #Werbungs Spruch mit Nicknamen
sub werb_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);

        if (my $error=check_gagged($main))
	{
		return $error;
	}

       else
{
	return [$main->createErrorOutput('kick_namenotgiven')] unless defined($nick);

	my $candidates = $main->getPossibleOnlineUsers($nick);

	return [$main->createErrorOutput('notonline',{nick => $nick})] if ($#$candidates < 0);
	return [$main->createErrorOutput('ambiguousname',{nick => $nick})] if ($#$candidates > 0);

	my $user = $candidates->[0];

        return [$main->createErrorOutput('werb_self')] if ($user->{name} eq $main->{current_user}{name});


	my $info = $main->createInfoOutput('werbed',
					{
						admin => $main->{current_user}{nick},
						nick => $user->{nick},
					});
	$info->restrictToCurrentRoom();

	return [$info];
}

}

                   #Wirr Spruch ohne Nicknamen
sub wirr_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);

        if (my $error=check_gagged($main))
	{
		return $error;
	}

       else
{
	my $candidates = $main->getPossibleOnlineUsers($nick);

	my $user = $candidates->[0];

	my $info = $main->createInfoOutput('wirred',
					{
						admin => $main->{current_user}{nick},
					});
	$info->restrictToCurrentRoom();

	return [$info];
}

}

                   #Wink Spruch mit Nicknamen
sub wink_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);

        if (my $error=check_gagged($main))
	{
		return $error;
	}

       else
{
	return [$main->createErrorOutput('kick_namenotgiven')] unless defined($nick);

	my $candidates = $main->getPossibleOnlineUsers($nick);

	return [$main->createErrorOutput('notonline',{nick => $nick})] if ($#$candidates < 0);
	return [$main->createErrorOutput('ambiguousname',{nick => $nick})] if ($#$candidates > 0);

	my $user = $candidates->[0];

        return [$main->createErrorOutput('wink_self')] if ($user->{name} eq $main->{current_user}{name});


	my $info = $main->createInfoOutput('winked',
					{
						admin => $main->{current_user}{nick},
						nick => $user->{nick},
					});
	$info->restrictToCurrentRoom();

	return [$info];
}

}

                   #Wein Spruch ohne Nicknamen
sub wein_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);

        if (my $error=check_gagged($main))
	{
		return $error;
	}

       else
{
	my $candidates = $main->getPossibleOnlineUsers($nick);

	my $user = $candidates->[0];

	my $info = $main->createInfoOutput('weined',
					{
						admin => $main->{current_user}{nick},
					});
	$info->restrictToCurrentRoom();

	return [$info];
}

}

                   #Winke Runde Spruch ohne Nicknamen
sub rund_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);

        if (my $error=check_gagged($main))
	{
		return $error;
	}

       else
{
	my $candidates = $main->getPossibleOnlineUsers($nick);

	my $user = $candidates->[0];

	my $info = $main->createInfoOutput('runded',
					{
						admin => $main->{current_user}{nick},
					});
	$info->restrictToCurrentRoom();

	return [$info];
}

}

                   #Abo Spruch mit Nicknamen
sub abo_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);

        if (my $error=check_gagged($main))
	{
		return $error;
	}

       else
{
	return [$main->createErrorOutput('kick_namenotgiven')] unless defined($nick);

	my $candidates = $main->getPossibleOnlineUsers($nick);

	return [$main->createErrorOutput('notonline',{nick => $nick})] if ($#$candidates < 0);
	return [$main->createErrorOutput('ambiguousname',{nick => $nick})] if ($#$candidates > 0);

	my $user = $candidates->[0];

        return [$main->createErrorOutput('abo_self')] if ($user->{name} eq $main->{current_user}{name});


	my $info = $main->createInfoOutput('aboed',
					{
						admin => $main->{current_user}{nick},
						nick => $user->{nick},
					});
	$info->restrictToCurrentRoom();

	return [$info];
}

}

                   #Knuddel Spruch mit Nicknamen
sub knuddel_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);

        if (my $error=check_gagged($main))
	{
		return $error;
	}

       else
{
	return [$main->createErrorOutput('kick_namenotgiven')] unless defined($nick);

	my $candidates = $main->getPossibleOnlineUsers($nick);

	return [$main->createErrorOutput('notonline',{nick => $nick})] if ($#$candidates < 0);
	return [$main->createErrorOutput('ambiguousname',{nick => $nick})] if ($#$candidates > 0);

	my $user = $candidates->[0];

        return [$main->createErrorOutput('knuddel_self')] if ($user->{name} eq $main->{current_user}{name});


	my $info = $main->createInfoOutput('knuddeled',
					{
						admin => $main->{current_user}{nick},
						nick => $user->{nick},
					});
	$info->restrictToCurrentRoom();

	return [$info];
}

}

                   #Wecken Spruch mit Nicknamen
sub wecken_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);

        if (my $error=check_gagged($main))
	{
		return $error;
	}

       else
{
	return [$main->createErrorOutput('kick_namenotgiven')] unless defined($nick);

	my $candidates = $main->getPossibleOnlineUsers($nick);

	return [$main->createErrorOutput('notonline',{nick => $nick})] if ($#$candidates < 0);
	return [$main->createErrorOutput('ambiguousname',{nick => $nick})] if ($#$candidates > 0);

	my $user = $candidates->[0];

        return [$main->createErrorOutput('wecken_self')] if ($user->{name} eq $main->{current_user}{name});


	my $info = $main->createInfoOutput('weckened',
					{
						admin => $main->{current_user}{nick},
						nick => $user->{nick},
					});
	$info->restrictToCurrentRoom();

	return [$info];
}

}

                   #Warn1 Spruch mit Nicknamen
sub warn1_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);

        if (my $error=check_gagged($main))
	{
		return $error;
	}

       else
{
	return [$main->createErrorOutput('kick_namenotgiven')] unless defined($nick);

	my $candidates = $main->getPossibleOnlineUsers($nick);

	return [$main->createErrorOutput('notonline',{nick => $nick})] if ($#$candidates < 0);
	return [$main->createErrorOutput('ambiguousname',{nick => $nick})] if ($#$candidates > 0);

	my $user = $candidates->[0];

        return [$main->createErrorOutput('warn1_self')] if ($user->{name} eq $main->{current_user}{name});


	my $info = $main->createInfoOutput('warn1ed',
					{
						admin => $main->{current_user}{nick},
						nick => $user->{nick},
					});
	$info->restrictToCurrentRoom();

	return [$info];
}

}


                   #Warn2 Spruch mit Nicknamen
sub warn2_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);

        if (my $error=check_gagged($main))
	{
		return $error;
	}

       else
{
	return [$main->createErrorOutput('kick_namenotgiven')] unless defined($nick);

	my $candidates = $main->getPossibleOnlineUsers($nick);

	return [$main->createErrorOutput('notonline',{nick => $nick})] if ($#$candidates < 0);
	return [$main->createErrorOutput('ambiguousname',{nick => $nick})] if ($#$candidates > 0);

	my $user = $candidates->[0];

        return [$main->createErrorOutput('warn2_self')] if ($user->{name} eq $main->{current_user}{name});


	my $info = $main->createInfoOutput('warn2ed',
					{
						admin => $main->{current_user}{nick},
						nick => $user->{nick},
					});
	$info->restrictToCurrentRoom();

	return [$info];
}

}

                   #notime Spruch mit Nicknamen
sub notime_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);

        if (my $error=check_gagged($main))
	{
		return $error;
	}

       else
{
	return [$main->createErrorOutput('kick_namenotgiven')] unless defined($nick);

	my $candidates = $main->getPossibleOnlineUsers($nick);

	return [$main->createErrorOutput('notonline',{nick => $nick})] if ($#$candidates < 0);
	return [$main->createErrorOutput('ambiguousname',{nick => $nick})] if ($#$candidates > 0);

	my $user = $candidates->[0];

        return [$main->createErrorOutput('notime_self')] if ($user->{name} eq $main->{current_user}{name});


	my $info = $main->createInfoOutput('notimeed',
					{
						admin => $main->{current_user}{nick},
						nick => $user->{nick},
					});
	$info->restrictToCurrentRoom();

	return [$info];
}

}

                   #Erotik Spruch ohne Nicknamen
sub erotik_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);

        if (my $error=check_gagged($main))
	{
		return $error;
	}

       else
{
	my $candidates = $main->getPossibleOnlineUsers($nick);

	my $user = $candidates->[0];

	my $info = $main->createInfoOutput('erotiked',
					{
						admin => $main->{current_user}{nick},
					});
	$info->restrictToCurrentRoom();

	return [$info];
}

}