###################################################################
#  GTChat 0.95 Alpha Plugin                                       #
#  Written for release 20021101                                   #
#  Author: BrownWolf                                              #
#                                                                 #
#  This plugin provides the warn command /warn                    #
###################################################################

package GTChat::Plugins::warn;
use strict;

return bless({
	command_handlers => {
		'warn' => \&commandHandler,
                'entwarn' => \&entwarnHandler,
	},
});




sub commandHandler
{
        my($self,$main,$command,$text) = @_;
	my ($nick) = split(/\s+/,$text);
	return [$main->createErrorOutput('warn_nonick')] unless defined($nick);
	my $candidates = $main->getPossibleOnlineUsers($nick);
	return [$main->createErrorOutput('notonline',{nick => $nick})] if ($#$candidates < 0);
	return [$main->createErrorOutput('ambiguousname',{nick => $nick})] if ($#$candidates > 0);
	my $user = $candidates->[0];
        return [$main->createErrorOutput('warn_isadmin')] if($user->{tempgroup} > 0);
	my $send = $main->createInfoOutput('warn_send',{nick => $user->{nick}});
	my $warn = $main->createInfoOutput('warned',{nick => $main->{current_user}{nick}})->restrictToUser($user->{name});
	my $handle = $main->loadUser($user->{name});
	$handle->{warns}++;
	$main->saveUser($handle);
	return [$send,$warn];
}


sub entwarnHandler
{
        my($self,$main,$command,$text) = @_;
	my ($nick) = split(/\s+/,$text);
	return [$main->createErrorOutput('entwarn_nonick')] unless defined($nick);
	my $candidates = $main->getPossibleOnlineUsers($nick);
	return [$main->createErrorOutput('notonline',{nick => $nick})] if ($#$candidates < 0);
	return [$main->createErrorOutput('ambiguousname',{nick => $nick})] if ($#$candidates > 0);
	my $user = $candidates->[0];
	return [$main->createErrorOutput('entwarn_self')] if($user->{nick} eq $main->{current_user}{nick});
        return [$main->createErrorOutput('entwarn_admin')] if($user->{tempgroup} > 0);
	my $send = $main->createInfoOutput('entwarn_send',{nick => $user->{nick}});
	my $warn = $main->createInfoOutput('entwarned',{nick => $main->{current_user}{nick}})->restrictToUser($user->{name});
	my $handle = $main->loadUser($user->{name});
	$handle->{warns}--;
	$main->saveUser($handle);
	return [$send,$warn];
}