###################################################################
#  GTChat 0.95 Alpha Plugin                                       #
#  Written for release 20021101                                   #
#  Author: Dennis Kasper                                          #
#                                                                 #
#  This plugin provides the chat commands /warn and /entwarn      #
###################################################################

package GTChat::Plugins::AdminCommands::095_01;
use strict;

return bless({
	command_handlers => {
		'warn' => \&warn_handler,
                                'entwarn' => \&entwarn_handler,
		
	},
});

sub warn_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);
	
	return [$main->createErrorOutput('kick_namenotgiven')] unless defined($nick);
	
	my $candidates = $main->getPossibleOnlineUsers($nick);
	
	return [$main->createErrorOutput('notonline',{nick => $nick})] if ($#$candidates < 0);
	return [$main->createErrorOutput('ambiguousname',{nick => $nick})] if ($#$candidates > 0);

	my $user = $candidates->[0];

	return [$main->createErrorOutput('warn_admin',{nick => $user->{nick}})] if ($user->{tempgroup} > 0);
               


	
                $main->loadUser($user->{name},$user);
                $user->{warns}=$user->{warns} +1;
	$main->saveUser($user);


	

	                my $output1 = $main->createInfoOutput('warn_make',
					{
						nick => $user->{nick},
					});
		my $output2 = $main->createInfoOutput('warn_get',
					{
						admin => $main->{current_user}{nick},
					});
		return [$output1->restrictToCurrentUser, $output2->restrictToUser($user->{name})];
}

sub entwarn_handler
{
	my($self,$main,$command,$text) = @_;

	my ($nick) = split(/\s+/,$text);
	
	return [$main->createErrorOutput('kick_namenotgiven')] unless defined($nick);
	
	my $candidates = $main->getPossibleOnlineUsers($nick);
	
	return [$main->createErrorOutput('notonline',{nick => $nick})] if ($#$candidates < 0);
	return [$main->createErrorOutput('ambiguousname',{nick => $nick})] if ($#$candidates > 0);

	my $user = $candidates->[0];

	return [$main->createErrorOutput('entwarn_admin',{nick => $user->{nick}})] if ($user->{tempgroup} > 0);
               
               


	
                $main->loadUser($user->{name},$user);
                return [$main->createErrorOutput('entwarn_iszero',{nick => $user->{nick}})] if ($user->{warns} == 0);
                $user->{warns}=$user->{warns} -1;
	$main->saveUser($user);


	

	                my $output1 = $main->createInfoOutput('entwarn_make',
					{
						nick => $user->{nick},
					});
		my $output2 = $main->createInfoOutput('entwarn_get',
					{
						admin => $main->{current_user}{nick},
					});
		return [$output1->restrictToCurrentUser, $output2->restrictToUser($user->{name})];
}




		