###################################################################
#  GTChat 0.95 Alpha Plugin                                       #
#  Written for release 20021225                                   #
#  Author: Wladimir Palant                                        #
#                                                                 #
#  This plugin writes a messages log to Variables/messages.log    #
#  and creates backup copies for it. The hash log_messages in     #
#  Settings.dat determines, which messages have to be logged.     #
###################################################################

package GTChat::Plugins::BadusersLog::095_02;
use strict;

return bless({});

sub logOutputStrings
{
	my($self,$main,$commands) = @_;

	my @commands = grep {$main->{settings}{log_badusers}{(split(/\|/,$_->[2]))[0]}} @$commands;
	return if $#commands<0;

	$main->open(local *LOG, '>>'.$main->translateName('vardir::badusers.log'));
	foreach (@commands)
	{
		my $user = defined($_->[0])?$_->[0]:'';
		my $room = defined($_->[1])?$_->[1]:'';
		print LOG "$main->{runtime}{now}|$user|$room|$_->[2]\n";
	}

	if ($main->{settings}{max_messageslog_size}>0 && $main->{settings}{messageslog_backups_count}>0 && tell(LOG)>$main->{settings}{max_messageslog_size})
	{               # rotate log now
		unlink($main->translateName("vardir::badusers.$main->{settings}{messageslog_backups_count}.log"));
		for (my $i=$main->{settings}{messageslog_backups_count}-1;$i>=0;$i--)
		{
			my $j=$i+1;
			rename($main->translateName("vardir::badusers.$i.log"),$main->translateName("vardir::badusers.$j.log"));
		}
		$main->close(*LOG);
		rename($main->translateName("vardir::badusers.log"),$main->translateName("vardir::badusers.1.log"));
	}
	else
	{
		$main->close(*LOG);
	}
}
