###########################################################################
#  GTChat 0.95 Alpha Plugin                                               #
#  Written for release 20021225                                           #
#  Author: Wladimir Palant                                                #
#                                                                         #
#  This plugin writes a private log to Variables/private/private.log      #
#  and creates backup copies for it. The hash log_private in              #
#  Settings.dat determines, which private have to be logged.              #
###########################################################################

package GTChat::Plugins::PrivateLog::095_02;
use strict;

return bless({});

sub logOutputStrings
{
	my($self,$main,$commands) = @_;

	my @commands = grep {$main->{settings}{log_private}{(split(/\|/,$_->[2]))[0]}} @$commands;
	return if $#commands<0;

	$main->open(local *LOG, '>>'.$main->translateName('privatelogdir::private.log'));
	foreach (@commands)
	{
		my $user = defined($_->[0])?$_->[0]:'';
		my $room = defined($_->[1])?$_->[1]:'';
		print LOG "$main->{runtime}{now}|$user|$room|$_->[2]\n";
	}

	if ($main->{settings}{max_privatelog_size}>0 && $main->{settings}{privatelog_backups_count}>0 && tell(LOG)>$main->{settings}{max_privatelog_size})
	{               # rotate log now
		unlink($main->translateName("privatelogdir::private.$main->{settings}{privatelog_backups_count}.log"));
		for (my $i=$main->{settings}{privatelog_backups_count}-1;$i>=0;$i--)
		{
			my $j=$i+1;
			rename($main->translateName("privatelogdir::private.$i.log"),$main->translateName("privatelogdir::private.$j.log"));
		}
		$main->close(*LOG);
		rename($main->translateName("privatelogdir::private.log"),$main->translateName("privatelogdir::private.1.log"));
	}
	else
	{
		$main->close(*LOG);
	}
}
