################################################################################
#  GTChat 0.95 Alpha Plugin                                                    #
#  Written for release 20030110                                                #
#  Author: Norman Rath                                                         #
#                                                                              #
#  This Plugin send a chatmail to a chatter                                    #
#                                                                              #
################################################################################

package GTChat::Plugins::ChatMail;

use strict;

return bless({
	template_var_handlers => {
		'chatmail' => \&handler,
	},
});

sub handler
{
	my ($self,$main,$from) = @_;

	return [$main->{template_vars}{chatmail_send} = 0] if(!$main->{input}{mailtext});

	my $user = $main->loadUser($main->{input}{username});

	$user->{fromnick} = $main->{current_user}{nick};
	$user->{fromemail} = $main->{current_user}{email};
	$user->{mailtext} = $main->{input}{mailtext};
	$user->{showmail} = $main->{input}{showmail};

	$main->{template_vars}{user} = $user;
	$main->sendMailTemplate('mails/chatmail');
	$main->{template_vars}{chatmail_send} = 1;
}

