###################################################################
#  GTChat 0.95 Alpha Plugin                                       #
#  Written for release 20021101                                   #
#  Author: Wladimir Palant                                        #
#                                                                 #
#  This plugin provides the template variables that are necessary #
#  for the chat chattreff. The information is taken from the file     #
#  Variables/chattreff.txt.                                       #
###################################################################

package GTChat::Plugins::ChatTreff::095_02;
use strict;

@GTChat::Plugins::ChatTreff_enum::095_02::ISA = ('GTChat::Enum');

return bless({
	template_var_handlers => {
		'chattreff.messagenum' => \&handler,
		'chattreff.message' => \&handler,
		'chattreff.author' => \&handler,
		'chattreff.date' => \&handler,

		'chattreff.messages' => \&handler,
		'chattreff.messagecount' => \&handler,
	},
});

sub handler
{
	my($self,$main,$var) = @_;

	$main->open(local *CHATTREFF, $main->translateName('vardir::chattreff.txt')) || return;
	my @messages = <CHATTREFF>;
	$main->close(*CHATTREFF);

	return if ($#messages < 0);

	my $num = int(rand($#messages+1));
	$messages[$num] =~ s/[\n\r]//g;
	my ($message,$author,$date) = split(/\|/,$messages[$num]);
	
	my %ret = (
		messagenum => $num,
		message => $message,
		author => $author,
		date => $date,
		messagecount => $#messages+1,
	);

	if ($var eq 'chattreff.messages')
	{
		my $enum = $main->{modules}{'sourcedir::Enum.pm'};
		$ret{messages} = GTChat::Plugins::ChatTreff_enum::095_02->new($main,\@messages);
	}

	$main->{template_vars}{chattreff} = \%ret;
}


package GTChat::Plugins::ChatTreff_enum::095_02;

sub new
{
	my($self,$main,$list) = @_;

	return bless({
		main => $main,
		list => $list,
		index => -1,
		opened => 0,
	});
}

sub open
{
	my $self=shift;

	$self->{closed} if $self->{opened};

	$self->{index} = -1;
	$self->{opened} = 1;
}

sub hasNext
{
	my $self=shift;
	return ($self->{opened} && $self->{index} < $#{$self->{list}});
}

sub next
{
	my $self=shift;
	
	return undef unless $self->{opened} && $self->{index} < $#{$self->{list}};

	$self->{index}++;
	$self->{list}[$self->{index}] =~ s/[\n\r]//g;
	
	my %ret = ();
	@ret{'message', 'author', 'date'} = split(/\|/,$self->{list}[$self->{index}]);
	return \%ret;
}

sub close
{
	my $self=shift;
	
	$self->{opened} = 0;
}
