################################################################################
#  GTChat 0.95 Alpha Plugin                                                    #
#  Written for release 20030110                                                #
#  Author: Norman Rath                                                         #
#                                                                              #
#  This plugin is a ImageUploadPlugin for the userprofile                      #
#                                                                              #
################################################################################

package GTChat::Plugins::ImageUpload;
use strict;

bless({
	template_var_handlers => {
		'imageupload' => \&handler,
	},
});

sub handler
{
	my($self,$main,$user) = @_;

	### Konfiguration Beginn ###

	my $image_dir = "./../chat_html/memberimages/";	# Verzeichnis der Bilder relativ zu chat.pl oder baseurl
	my $image_ext = "gif|jpg|png|bmp";	# erlaubte Dateiendungen fr Upload getrennt durch |
	my $image_max = "50";			# erlaubte Dateigre fr Upload in KB

	### Konfiguration Ende ###

	my $filename = $main->{input}{username};
	$filename = $main->{current_user}{name} if(!$main->{input}{username});
	$filename =~ s/[\/\\]/_/g;

	my @image_ext = split(/\|/,$image_ext);

	foreach(@image_ext)
	{
		if(-e $image_dir.$filename.".".$_)
		{
			$filename .= ".".$_;
		}
	}

	$filename = "" if($filename eq $main->{input}{username} or $filename eq $main->{current_user}{name});

	if($main->{input}{image_upload})
	{
		$user = $main->loadUser($main->{input}{username});
		$user = $main->loadUser($main->{current_user}{name}) if(!$main->{input}{username});

		if($main->{input}{image_activate})
		{
#			$user->{group} = 1 if($user->{tempgroup} < 1);
			$user->{image_activate} = 1;
			$main->{template_vars}{user} = $user;
			$main->sendMailTemplate('mails/image_activate');
		}

		if($main->{input}{image_delete})
		{
#			$user->{group} = 0 if($user->{tempgroup} == 1);
			$user->{image_activate} = 0;
			if($main->{input}{username} ne $main->{current_user}{name})
			{
				$main->{template_vars}{user} = $user;
				$main->sendMailTemplate('mails/image_delete');
			}
		}

		if($main->{input}{image_new})
		{
#			$user->{group} = 0 if($user->{tempgroup} <= 1);
			$user->{image_activate} = 0;
			$user->{toemail} = $main->{settings}{webmaster_email};
			$main->{template_vars}{user} = $user;
			$main->sendMailTemplate('mails/image_new');
		}

		$main->saveUser($user);
		$main->{template_vars}{user_information} = $user;
	}

	$main->{template_vars}{image_error} = 1 if($main->{input}{image_ext});
	$main->{template_vars}{image_error} = 2 if($main->{input}{image_max});
	$main->{template_vars}{image_dir} = $image_dir;
	$main->{template_vars}{image_ext} = $image_ext;
	$main->{template_vars}{image_max} = $image_max;
	$main->{template_vars}{image} = $filename;
}

