################################################################################
#                                                                              #
#  Kiss.pm 0.95a40115                                                        #
#                                                                              #
#  GTChat 0.95 Alpha Plugin                                                    #
#  Written for release 20040112                                                #
#  Author: Norman Rath                                                         #
#  E-Mail: Norman.Rath@o2online.de                                             #
#                                                                              #
#  Send a Kiss to your friend                                                 #
#                                                                              #
################################################################################

package GTChat::Plugins::VarHandlers::Kiss;
use strict;

bless({
	template_var_handlers => {
		'kiss' => \&handlerKissProfil,
		'kiss_send' => \&handlerKissSend,
	},
});

sub handlerKissSend
{
	my($self,$main) = @_;

	my $user = $main->loadUser($main->{input}{username});

	my $existsuser;

	foreach (split(/\|/,$user->{kiss}))
	{
		if($_ eq $main->{current_user}{name})
		{
			$existsuser = 1;
			last;
		}
	}

	return [$main->{template_vars}{kiss_send} = 3] if($existsuser);

	if(($main->{runtime}{now} - $main->{current_user}{lastsendkiss}) < 604800)
	{
		$main->{template_vars}{kiss_send} = 1;
		return [$main->{template_vars}{kiss_days} = sprintf "%.1f",((604800 - ($main->{runtime}{now} - $main->{current_user}{lastsendkiss})) / 86400)];
	}

	### START PointSystem.pm-Zugehrigkeit ###
	if($main->{current_user}{points} < 111)
	{
		$main->{template_vars}{kiss_send} = 2;
		return [$main->{template_vars}{kiss_points} = sprintf "%.1f",(111 - $main->{current_user}{points})];
	}

	$main->{current_user}{points} -= 111;
	### ENDE PointSystem.pm-Zugehrigkeit ###

	$main->{current_user}{lastsendkiss} = $main->{runtime}{now};
	$main->saveUser($main->{current_user});

	if($user->{kiss})
	{
		$user->{kiss} = $user->{kiss}."|".$main->{current_user}{name};
	}
	else
	{
		$user->{kiss} = $main->{current_user}{name};
	}

	$main->saveUser($user);

	$main->{template_vars}{kiss_send} = 0;
}

sub handlerKissProfil
{
	my($self,$main) = @_;

	my $user = $main->loadUser($main->{input}{username});

	my @ret=();

	foreach (split(/\|/,$user->{kiss}))
	{
		$user = $main->loadUser($_);
		push @ret, $user->{nick};
	}

	$main->{template_vars}{kiss} = \@ret;
}

