###################################################################
#  GTChat 0.95 Alpha Plugin                                       #
#  Written for release 20021101                                   #
#  Author: Norman Rath                                            #
#                                                                 #
#  This plugin tracert the user ip                                #
###################################################################

package GTChat::Plugins::Tracert;
use strict;

bless({
	template_var_handlers => {
		'tracert' => \&handler,
	},
});

sub handler
{
	my($self,$main,$user,$route) = @_;

	$user = $main->loadUser($main->{input}{username});

	if ($^O !~ /win/i)
	{
		my $z;
		my @wert = ();

		open(TR,"traceroute $user->{ip} 2>&1|");
		$route = qq~<table width=100%>~;
		while(<TR>)
		{
			$z++;
			if ($_ !~ /interface/i && $z != 1)
			{
				$_ =~ s/\* /\*/g;
				$_ =~ s/\ ms/\&nbsp\;ms/g;
				@wert = split(' ',$_);
				$route .= qq~<tr><td>$wert[0]</td><td>$wert[1]</td><td>$wert[2]</td><td>$wert[3]</td><td>$wert[4]</td><td>$wert[5]</td><td>$wert[6]</td></tr>~;
			}
			else
			{
				$route .= qq~<tr><td colspan=7>$_</td></tr>~;
			}
		}
		$route .= "</table>";
		close(TR);
	}
	else
	{
		$route = `tracert $user->{ip}`;
	}

	$main->{template_vars}{tracert} = $route;
}
