###################################################################
#  GTChat 0.95 Alpha Plugin                                       #
#  Written for release 20021101                                   #
#  Author: BrownWolf                                              #
#                                                                 #
#  This plugin provides the dupes command /dupeip                 #
###################################################################

package GTChat::Plugins::dupes;
use strict;

return bless({
	command_handlers => {
		'dupeip' => \&commandHandler,
	},
});

sub commandHandler
{
	my($self,$main,$command,$text) = @_;
	my(%dupes,@results);
	my $list = $main->getOnlineUsers();
	foreach my $online(@$list) {
		$online = $main->translateOnlineString($online);
		$main->loadUser($online->{name}, $online);
                my $ip = $online->{ip};
       		push(@{$dupes{$ip}}, $online->{nick});  
	}
        while(my($ip,$users) = each %dupes){
		if(scalar(@$users) < 2){
                delete $dupes{$ip};
		}else{
		push(@results, "[ @$users <$ip> ]");
		}
        }
	$text = scalar @results < 1 ? "Keine" : join " ", @results;
	my $output = $main->createInfoOutput('dupeip',{dupes => $text});   
        return [$output];
	
}
